#! /usr/bin/perl
#Name: R4-client.perl
#Project: R4 control
#Homepage: www.HomoFaciens.de
#Author Norbert Heinz
#Version: 1.0
#Creation date: 19.01.2016
#Copyright: (c) 2016 by Norbert Heinz
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#


use strict;
use LWP::UserAgent;
use HTTP::Request::Common;
use Getopt::Long;
use File::Basename;
use LWP::Simple;
use Time::HiRes qw(usleep nanosleep);

$|=1 ;

my $i;
my @file_info;
my $file_size = 0;
my $char_temp = "";
my $wait_count = 0;
my $driveDistance = 0;
my $driveDirection = 1;
my $cameraAngle = 0;
my ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time);
my $script_answer = "";
my $upload_command = "";
my $upload_status = 0;
my $stream = 0;
my $CommandStartTime = 0;
my $firstAccessTime = 0;
my $lastAccessTime = 0;


my $password = "TypeYourPassword";

my $url_ask_command = 'http://127.0.0.1/perl/R4-simplified/SendCurrentCommand.pl?passwd=' . $password ;



&ExecuteCommandLine("killall -s SIGKILL R4C1", 0);
&ExecuteCommandLine("./R4C1 s 5", 0); #Light off

&ExecuteCommandLine("/home/pi/R4-simplified/stream-stop.sh", 0);

&ExecuteCommandLine("/etc/init.d/lirc stop", 0);


print "remote ip script_answer=>" . $script_answer . "<\n";

$script_answer = get $url_ask_command . "&status=FirstStart" . "&STREAM=" . $stream;
sleep(5);


while (1 == 1){

    
  $script_answer = get $url_ask_command . "&status=waiting" . "&STREAM=" . $stream;
  print "2.) script_answer=>" . $script_answer . "<, url_ask_command=>" . $url_ask_command . "&status=waiting" . "&STREAM=" . $stream . "<\n";

  while($script_answer eq "no job available"){
    &ExecuteCommandLine("./R4C1 s 254", 0);#Tell Arduino that Raspberry is still running
    if($wait_count == 20){# Sleep
      &ExecuteCommandLine("./R4C1 s 5", 0);  #Turn light off
      &ExecuteCommandLine("./R4C1 s 66", 0); #Turn camera servo off
    }

    $wait_count ++;
    print "wait_count = $wait_count\n";
    sleep(2);
    
    if($firstAccessTime > 0 && (time() - $firstAccessTime > 300 || time() - $lastAccessTime > 30)){
      print "Timeout 2\n";
      $script_answer = get $url_ask_command . "&status=FinishedAll" . "&STREAM=" . $stream;
      $firstAccessTime = 0;
      ExecuteCommandLine("./stream-stop.sh", 0);
      $stream = 0;
    }
    else{    
      $script_answer = get $url_ask_command . "&status=waiting" . "&STREAM=" . $stream;
    }
    
    print "3.) script_answer=>" . $script_answer . "<\n";
  }

  if($script_answer eq "reset jobs"){
    $lastAccessTime = time();
    print "Resetting job pipeline\n";
    $stream = 0;
    ExecuteCommandLine("./stream-stop.sh", 0);   
  }

  if(substr($script_answer, 0, 5) eq "Comm="){
    $lastAccessTime = time();
    if($firstAccessTime == 0){
      $firstAccessTime = time();
      ExecuteCommandLine("./stream.sh", 1);
      $stream = 1;
    }
    $CommandStartTime = time();
    $wait_count = 0;
    print "\n\nReceived command '" . $script_answer . "'\n\n";


    if(substr($script_answer, 14, 1) eq "3"){#Restart video stream
      print "Restart video stream. Remote ip script_answer=>" . $char_temp . "<\n";
      ExecuteCommandLine("./stream.sh", 1);
      $stream = 1;
    }
    

    if(substr($script_answer, 13, 1) eq "0"){#Lights off
      &ExecuteCommandLine("./R4C1 s 5", 0);
    }
    if(substr($script_answer, 13, 1) eq "1"){#Light low
      &ExecuteCommandLine("./R4C1 s 1", 0);
    }
    if(substr($script_answer, 13, 1) eq "2"){
      &ExecuteCommandLine("./R4C1 s 2", 0);
    }
    if(substr($script_answer, 13, 1) eq "3"){
      &ExecuteCommandLine("./R4C1 s 3", 0);
    }
    if(substr($script_answer, 13, 1) eq "4"){#Light highest possible
      &ExecuteCommandLine("./R4C1 s 4", 0);
    }

    $cameraAngle = substr($script_answer, 11, 2);
    if($cameraAngle < 1 || $cameraAngle > 20){
      print "cameraAngle=$cameraAngle out of range!\n";
      $cameraAngle = 11;
      &ExecuteCommandLine("./R4C1 s 66", 0); #Turn servo off
    }
    else{
      $cameraAngle += 46;
      &ExecuteCommandLine("./R4C1 s " . $cameraAngle, 0);
    }

    $driveDistance = substr($script_answer, 7, 2);
    if($driveDistance < 0 | $driveDistance > 10){
      print "driveDistance=$driveDistance out of range!\n";
      $driveDistance = 0;
    }

    if($driveDistance > 0){
      if(substr($script_answer, 6, 1) eq "2" || substr($script_answer, 6, 1) eq "5"){#turn right
        $driveDistance += 25;
        &ExecuteCommandLine("./R4C1 s " . $driveDistance, 0);
        $driveDistance = 0;
      }
      if(substr($script_answer, 6, 1) eq "1" || substr($script_answer, 6, 1) eq "4"){#turn left
        $driveDistance += 35;
        &ExecuteCommandLine("./R4C1 s " . $driveDistance, 0);
        $driveDistance = 0;
      }
    }


    if($driveDistance > 0){
      if(substr($script_answer, 6, 1) eq "0" || substr($script_answer, 6, 1) eq "1" || substr($script_answer, 6, 1) eq "2"){#Forward straight
        $driveDistance += 5;
        &ExecuteCommandLine("./R4C1 s " . $driveDistance, 0);
        $driveDirection = 1;
      }
      else{
        $driveDistance += 15;
        &ExecuteCommandLine("./R4C1 s " . $driveDistance, 0);
        $driveDirection = 2;
      }
    }

    print "Start processing...\n";
    while(time() - $CommandStartTime < 2){#Next command after at least ...s
      $i++;
    }
  }#if(substr($script_answer, 0, 5) eq "Comm="){


  usleep(500000); #Do nothing for 0.5 seconds before proceeding the next command
  if($firstAccessTime > 0 && (time() - $firstAccessTime > 300 || time() - $lastAccessTime > 30)){
    print "Timeout 2: firstAccessTime = $firstAccessTime\n";
    $script_answer = get $url_ask_command . "&status=FinishedAll" . "&STREAM=" . $stream;
    $firstAccessTime = 0;
    ExecuteCommandLine("./stream-stop.sh", 0);
    $stream = 0;
  }
  else{
    $script_answer = get $url_ask_command . "&status=finished" . "&STREAM=" . $stream;
  }

  &ExecuteCommandLine("./R4C1 s 254", 0);#Tell Arduino that Raspberry is still running
  
}#while (1 == 1)



#++++++++++++++++++++++ ExecuteCommandLine ++++++++++++++++++++++++++++++++++++++++++++++++++
sub ExecuteCommandLine{
  print $_[0] . "\n";
  if($_[1] == 0){
    `$_[0]`;
  }
  else{
#    `$_[0]`;
    system ($_[0] . "&");
  }
}
