#! /usr/bin/perl
#Project: R4 control
#Homepage: www.HomoFaciens.de
#Author Norbert Heinz
#Version: 1.0
#Creation date: 19.01.2016
#Copyright: (c) 2016 by Norbert Heinz
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#

use strict;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);

my $numArgs = 0;
my $argument_user = "";
my $argument_command = "";
my $user_in_file = "";
my $file_access = "R4access.txt";
my $file_server_status = "R4-connect.txt";
my $in_line = "";
my $type_style =  '; font-family:serif,Times,serif; font-size:12px; color:#000000"';
my $type_style_large =  '; font-family:serif,Times,serif; font-size:20px; color:#000000"';
my $user_is_ok = 0;
my $temp_char = "";
my $i = 0;
my $allowed_chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_";
my $access_time = 0;
my $first_access_time = 0;
my $access_time = 0;
my @file_info;
my $file_size = 0;
my $file_out = "R4command.txt";
my $UserName = param("UserName");
my $Command = param("Command");

my $name_bitmap = "";


if($UserName ne ""){
  $numArgs++;
}

if($Command ne ""){
  $numArgs++;
}

print "Content-type: text/html\n\n";
print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">' . "\n";
print "<html><head><title>R4 Status</title>" . "\n";

print "</head><body>";
print '<table border="0" cellpadding="0" cellspacing="0"><tr>' . "\n";


  if($numArgs < 1){#Script has to be called with at least 1 Argument
    print '<td style="background-color:#FF0000' . $type_style . '">Not enough parameters given!</td></tr></table></body></html>';
    exit(0);
  }
  
    
  if(time() - (stat("LastCallFromRover.txt"))[9] > 30){#Connection R4-server cut
    print '<td style="background-color:#FF0000' . $type_style_large . '>R4 currently not connected.<br>Reconnection in progress...</td>';
    print "</tr></table></body></html>" . "\n";
    if(!(-e "LostConnection.bmp")){
      `cp IndicationPicture01.bmp LostConnection.bmp`;
    }
    exit(0);
  }
    
    
  if($numArgs == 2){#Call with Username and R4 command
    $argument_user = $UserName;
    $argument_user .= ( "                    ");
    $argument_user = substr($argument_user, 0, 20);

    $temp_char=$argument_user;
    $temp_char =~ s/^ +//;
    $temp_char =~ s/ +$//;
    for($i = 0; $i < length($temp_char); $i++){
      if(index($allowed_chars, substr($temp_char, $i, 1)) < 0) {
        print '<td style="background-color:#00FF00' . $type_style . '>Not allowed character in username!</td></tr></table><</body></html>';
        exit(0);
      }
    }

    $argument_command = $Command;
    $argument_command .= ( "                    ");
    $argument_command = substr($argument_command, 0, 20);
    $access_time = time() . "                    ";
    $access_time = substr($access_time, 0, 20);

    @file_info=stat($file_access);
    $file_size = $file_info[7];

    if ($file_size < 1000){
      open(DATEIOUT,'>>'.$file_access) || die '<td style="background-color:#FF0000' . $type_style . '>Can not open file' .  $file_access . '. Please try again.</td></tr></table></body></html>';
        print DATEIOUT $argument_user . "                                        " . $access_time . "_\n";
      close (DATEIOUT);
    }

    #Compare command line arguments with those iside of the first line in file R4access.txt
    open(DATEIIN, '<'.$file_access) || die '<td style="background-color:#FF0000' . $type_style . '>File ' .  $file_access . ' not found, please try again.</td></tr></table></body></html>';
      $in_line = <DATEIIN>;
    close (DATEIIN);

    $user_in_file = substr($in_line, 0, 20);
    $first_access_time = substr($in_line, 60, 20);

    $name_bitmap = $user_in_file;
    $name_bitmap =~ s/^\s+|\s+$//g;
    $name_bitmap = "UserDir/" . $name_bitmap . "-CurrentUser.bmp";
    if(!(-e $name_bitmap)){
      system("cp IndicationPicture01.bmp " . $name_bitmap);
      $name_bitmap = $user_in_file;
      $name_bitmap =~ s/^\s+|\s+$//g;
      $name_bitmap = "UserDir/" . $name_bitmap . ".usr";
      open(DATEIOUT, '>'.$name_bitmap) || die '<td style="background-color:#FF0000' . $type_style . '>File ' .  $name_bitmap . ' not found, please try again.</td></tr></table></body></html>';
        print DATEIOUT $ENV{'REMOTE_ADDR'};;
      close (DATEIOUT);
    }

    $name_bitmap = $user_in_file;
    $name_bitmap =~ s/^\s+|\s+$//g;
    $name_bitmap = $name_bitmap . "-CurrentUser.bmp";
    if(!(-e $name_bitmap)){
      system("cp IndicationPicture01.bmp " . $name_bitmap);
    }

    if ($argument_user eq $user_in_file){#User from commandline equals that at the first line of R4access.txt
      $user_is_ok = 1;
      print '<td style="background-color:#00FF00' . $type_style . '>R4 is under your control: "' . $user_in_file . '"</td>';
      if(-e $file_out){
        print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Command pipe not free for new command. Please try again in five seconds.</td>';
      }
      else{#Write command to file
        if(-e "RoverCommand.bmp"){
          `rm RoverCommand.bmp`;
        }
        
        $access_time = time() . "                    ";
        $access_time = substr($access_time, 0, 20);
        open(DATEIOUT,'>'.$file_out) || die '<td style="background-color:#FF0000' . $type_style . '>Can not open command file' .  $file_out . '. Please try again.</td></tr></table></body></html>';
          print DATEIOUT $argument_command . $access_time . "                    " . $user_in_file . "_\n";
        close (DATEIOUT);
        $argument_command =~ s/^ +//;
        $argument_command =~ s/ +$//;
        if(substr($Command, 9, 1) eq "1" || substr($Command, 9, 1) eq "2" || substr($Command, 9, 1) eq "3"){#Snapshot, restart stream
          open(DATEIOUT,'> ReconnectStream.txt') || die '<td style="background-color:#FF0000' . $type_style . '>Can not create ReconnectStream.txt!</td></tr></table></body></html>';
            print DATEIOUT "Comm=" . substr($argument_command, 1, 20);
          close (DATEIOUT);
          `rm -f StreamIsUp.gif`;  
          
          print '</tr><tr><td style="background-color:#FF0000' . $type_style . '">Restarting video stream - Please wait...</td>';  
        }
        else{
          print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $argument_command . ' sent to R4</td>';
        }
      }
    }#if ($argument_user eq $user_in_file)
    else{
      $user_is_ok = 2;
      print '<td style="background-color:#FF0000' . $type_style . '>R4 currently in use by: "' . $user_in_file . '"</td>';
      $user_in_file =~ s/^ +//;
      $user_in_file =~ s/ +$//;
      print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Please wait until R4 is free! After 5min the control is released.</td>';
    }#if ($argument_user eq $user_in_file) - else construct
  }#if($numArgs == 2){


  if($numArgs == 1){#Call without transmitted command (2nd argument). Display status.
    if($user_is_ok == 0){
      if( -e $file_access){
        open(DATEIIN, '<'.$file_access) || die '<td style="background-color:#FFFFFF' . $type_style . '>File ' .  $file_access . ' not found, please try again.</td></tr></table></body></html>';
          $in_line = <DATEIIN>;
        close (DATEIIN);
      }
      else{
        $in_line = "";
      }

      if($in_line eq ""){
        print '<td style="background-color:#FFFF00' . $type_style . '>R4 free for use. Press one of the command buttons to take control...</td>' . "\n";
      }
      else{
        $user_in_file = substr($in_line, 0, 20);
        $user_in_file =~ s/^ +//;
        $user_in_file =~ s/ +$//;
        $argument_user = $UserName;

        if($user_in_file eq $argument_user){
          print '<td style="background-color:#00FF00' . $type_style . '>R4 is under your control: "' . $user_in_file . '"</td>' . "\n";
        }
        else{
          print '<td style="background-color:#FF0000' . $type_style . '>R4 currently in use by: "' . $user_in_file . '"</td>' . "\n";
        }
        if (-e "R4command.txt"){
          print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>Processing current command - please wait (usually 10 to 30 seconds) for new pic.</td>' . "\n";
        }
        else{
          print '</tr><tr><td style="background-color:#FFFF00' . $type_style . '>Hello control station on planet Earth, press a control button to transmit the next instruction!</td>' . "\n";
        }
      }
    }#if($user_is_ok == 0)
  }#if($numArgs  == 1){


print "</tr></table></body></html>" . "\n";

exit (0);


